local _G = getfenv(0)

function Skinner:DoTimer()

	-- Hook these to Skin the DropDown frames
	self:SecureHook(DropDownLib, "CreateFrames", function(self, level, index)
--		Skinner:Debug("DDL_CF: [%s, %s, %s]", self, level, index)
		local ddFrame = "DropDownLibList"..level
		if _G[ddFrame] and not Skinner:IsHooked(_G[ddFrame], "OnShow") then
			Skinner:HookScript(_G[ddFrame], "OnShow", function()
				Skinner.hooks[_G[ddFrame]].OnShow()
				Skinner:keepFontStrings(_G[ddFrame])
				_G[ddFrame.."Backdrop"]:Hide()
				_G[ddFrame.."MenuBackdrop"]:Hide()
				Skinner:applySkin(_G[ddFrame])
				end)
		end
		end)
	
	--	Hook to skin the DOT Timers
	self:SecureHook(DoTimer, "CreateFrames", function(self, targets, timers)
--		Skinner:Debug("DT_CF: [%d, %d]", targets, timers)
		targets = math.max(targets, self.libraries["TimerLib"].totaltargets)
		timers  = math.max(timers, self.libraries["TimerLib"].totaltargets)
		local targetframe = self.libraries["TimerLib"].targetframe
		local timerframe  = self.libraries["TimerLib"].timerframe
		for i = 1, targets do
			for id = 1, timers do				Skinner:glazeStatusBar(getglobal(targetframe..i..timerframe..id.."BarStatus"))
Skinner:glazeStatusBar(getglobal(targetframe..i..timerframe..id.."BarBackground"))
			end	
		end
		end)
	
	--	Hook to skin the Timer GUI
	self:SecureHook(DoTimer, "ShowGUI", function()
		if not DoTimerMenuFrame.skinned then
			for k, v in pairs({ DoTimerMenuFrame:GetChildren() }) do
				if v.initialize then
					self:keepFontStrings(v)
				elseif v:GetFrameType() == "EditBox" then
					self:skinEditBox(v, {9})
				end
			end
			self:applySkin(DoTimerMenuFrame, true)
			DoTimerMenuFrame.skinned = true
		end
		end)
	
	--	Hook to skin the Profile GUI
	self:SecureHook(ProfileLib, "ShowGUI", function()
		if not ProfileMenuFrame.skinned then
			for k, v in pairs({ ProfileMenuFrame:GetChildren() }) do
			if v.initialize then
					self:keepFontStrings(v)
				elseif v:GetFrameType() == "EditBox" then
					self:skinEditBox(v, {9})
				end
			end
			self:applySkin(ProfileMenuFrame, true)
			ProfileMenuFrame.skinned = true
		end
		end)
	
	self:skinTooltip(SpellSystemScanningFrame)
	
	if IsAddOnLoaded("Cooldowns") then
		--	Hook to skin the Cooldown Timers
		self:SecureHook(Cooldowns, "CreateFrames", function(self, targets, timers)
--			Skinner:Debug("CT_CF: [%s, %s]", targets, timers)
			targets = math.max(targets, self.libraries["TimerLib"].totaltargets)
			timers  = math.max(timers, self.libraries["TimerLib"].totaltargets)
			local targetframe = self.libraries["TimerLib"].targetframe
			local timerframe  = self.libraries["TimerLib"].timerframe
			for i = 1, targets do
				for id = 1, timers do				Skinner:glazeStatusBar(getglobal(targetframe..i..timerframe..id.."BarStatus"))
	Skinner:glazeStatusBar(getglobal(targetframe..i..timerframe..id.."BarBackground"))
				end	
			end
			end)
		--	Hook to skin the Cooldowns GUI
		self:SecureHook(Cooldowns, "ShowGUI", function()
			if not CooldownsMenuFrame.skinned then
				for k, v in pairs({ CooldownsMenuFrame:GetChildren() }) do
					if v.initialize then
						self:keepFontStrings(v)
					elseif v:GetFrameType() == "EditBox" then
						self:skinEditBox(v, {9})
					end
				end
				self:applySkin(CooldownsMenuFrame, true)
				CooldownsMenuFrame.skinned = true
			end
			end)

	end

end
